#!/usr/bin/perl


  ### Include the standard library and define local variables.
  require 'tripwire-lib.pl';

  ### Print the header and a horizonal rule.
  &header("Tripwire Maintenance", "");


  ###
  ### Make sure tripwire is set up properly.
  ###
  my $HOSTNAME = `cat /proc/sys/kernel/hostname`;
  chomp $HOSTNAME;

  if ( (! -f "/etc/tripwire/$HOSTNAME-local.key") ||
       (! -f "/etc/tripwire/site.key") ||
       (! -f "/etc/tripwire/tw.cfg") ||
       (! -f "/etc/tripwire/tw.pol") ||
       (! -f "/var/lib/tripwire/$HOSTNAME.twd")) {

    print <<NOCONFIG;

<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
<TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Tripwire Maintenance</B></TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
  Before you use this module, you must first set up Tripwire on your machine.
  Unfortunately, this cannot be done thorough the WebTool at this time so it
  must be done from a shell.  Below are the steps you need to perform (you may
  want to print this page out).  Be sure that these commands are executed as
  the 'root' user.

<PRE>
    [root\@machine/root]# /etc/tripwire/twinstall.sh
    [root\@machine/root]# tripwire --init
</PRE>

  After you execute the 'twinstall.sh' script, you will be prompted for
  a "<B>site keyfile passphrase</B>" and a "<B>local keyfile passphrase</B>".
  These passphrases should follow the guidelines outlined by the install script.

  <P>After the keys are generated, you will be prompted for your "<B>site passphrase</B>"
  two times, as tripwire signs its configuration files with this key to ensure
  data integrity.

  <P>When that script is done, you can run the second command to initialize your database.
  You will be prompted for your "<B>local passphrase</B>" when initializing the database.
  If you see "No such file or directory" warnings do not be alarmed.  The configuration
  file provided in EnGarde covers a stock installation, with all services running.  If
  you have some services disabled then Tripwire will generate these harmless warnings.

  <P>Once these steps are performed, you can come back here to use the WebTool Tripwire
  module.
</TD></TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE></CENTER><P>

NOCONFIG

    &ryanFooter("/Security/");
  }
  else {

  print <<TABLE01;
<P><CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
<TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Tripwire Maintenance</B></TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
Below you can view reports and update your tripwire policy files.
</TD></TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="edit_email.cgi">Define Administrator</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Define where you want the daily report e-mailed to.
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="edit_schedule.cgi">Schedule Tripwire</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Define when you want tripwire to generate reports
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="generate_report.cgi">Generate Report</A>
    </B></DIV>
  </TD>
  <TD> <DIV CLASS=nbody>
         Generate a new report with the current state of the system.
  </DIV> </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="list_reports.cgi">View Reports</A>
    </B></DIV>
  </TD>
  <TD> <DIV CLASS=nbody> View and delete reports.  </DIV> </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD>
    <DIV CLASS=nbody><B>
      <A HREF="update_database.cgi">Update Database</A>
    </B></DIV>
  </TD>
  <TD>
    <DIV CLASS=nbody>
      Update the local database as per the most recent report.
    </DIV>
  </TD>
</TR>

<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
<TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE></CENTER><P>
TABLE01

    &ryanFooter("/Security/");
  }

